
module Base where

import Utils


-------------------- abstract syntax for lambda terms

data Term = Var Char | App Term Term | Lam Char Term     deriving Eq


-------------------- pretty-printing

instance Show Term where
  show (Var x)   = [x]
  show (App m n) = m `on` L +|+ n `on` R
  show  m        = lam ++ vs ++ "." +|+ show b
                   where (vs,b) = vars m

vars (Lam x n) = left (x:) (vars n)
vars t = ([],t)

t@(App _ _) `on` R = paren t
t@(Lam _ _) `on` _ = paren t
t           `on` _ = show t
