
module Defns where

import Utils


-------------------- standard definitions

defns = [
          ("I",      "λx. x"),
          ("K",      "λxy. x"),
          ("S",      "λfgx. f x (g x)"),
          ("OMEGA",  "(λx. x x) (λx. x x)"),
          ("Y",      "λf. (λx. f (x x)) (λx. f (x x))"),
          ("TRUE",   "λxy. x"),
          ("FALSE",  "λxy. y"),
          ("IF",     "λbte. bte"),
          ("ISZERO", "λz. z (λwxy.y) (λxy.x)"),
          ("ZERO",   "λfx. x"),
          ("ONE",    "λfx. f x"),
          ("SUCC",   "λkfx. f (k f x)"),
          ("PRED",   "λkfx. k (λgh. h (g f)) (λu.x) (λu.u)"),
          ("ADD",    "λmnfx. m f (n f x)"),
          ("MUL",    "λmnf. m (n f)"),
          ("POW",    "λmn. n m"),
          ("FAC",    "Y (λfn. ISZERO n ONE (MUL n (f (PRED n))))"),
          ("PRIM",   "Y (λpszn. ISZERO n z (s (p s z (PRED n))))"),
          ("PLUS",   "λn. PRIM SUCC n"),
          ("TIMES",  "λn. PRIM (PLUS n) ZERO")
        ]


-------------------- meta-variable environment

menv p = map (right p) defns

expand e v = case lookup v e of
               Just t  -> t
               Nothing -> error ("bad meta: " ++ v)
