
module Deno where

import Base
import Utils (upd)


-------------------- semantic domain

newtype Dom  = Fun (Dom -> Dom)

instance Show Dom where
  show (Fun f) = "<function>"


-------------------- denotational semantics

sem env (Var x)   = env x
sem env (Lam x m) = Fun (\z -> sem (upd env x z) m)
sem env (App m n) = case sem env m of
                      Fun f -> f (sem env n)

val = sem undefined