
module Generate where

import Base
import Calc
import Reduce
import RCalc
import List


-------------------- all terms of given size with given sets of free variables

bounds = "xyzuvwpqrst"

gen bvs fvs 0 = map Var fvs

gen bvs@(b:bs) fvs n = map (Lam b) (gen bs (b:fvs) (n-1)) ++
                       [App m n | i <- [0..n-1], 
                                  let j=(n-1)-i, 
                                  m <- gen bvs fvs i,
                                  n <- gen bvs fvs j]


-------------------- generation utility functions

try = gen bounds "abc"
clo = gen bounds ""


-------------------- generation with (formatted) reduction

cloe n = mapM fmtred' (zip [1..] (clo n))

fmtred' (k,e) = putStrLn ("\n" ++ show k ++ ". " ++ show e) 
                >> mapM_ (fmt "->>") (reds e)


-------------------- all size 5 terms except omega (attempt no landing there)

unw = mapM fmtred' $ (zip [1..] (clo 5 \\ [omega]))

omega = App w w
        where w = Lam 'x' (App x x)
              x = Var 'x'