
module Printer where

import Base hiding (on)
import Utils


-------------------- use "test" to print with full and minimum parens for comparison

test x = putStrLn (full x ++ "\n" ++ mini True x)

pars  str = "(" ++ str ++ ")"
space str = " " ++ str ++ " "


-------------------- full parentheses

full (Var x)   = [x]
full (App m n) = pars (full m +|+ full n)
full  m        = pars (lam ++ vs ++ "." +|+ full b)
                 where (vs,b) = vars m


-------------------- minimum parentheses

mini _ (Var x)   = [x]
mini b (App m n) = (if b then space else id) (m `on` L +|+ n `on` R)
mini b  m        = (if b then space else id) (lam ++ vs ++ "." +|+ mini True n)
                   where (vs,n) = vars m

t@(App _ _) `on` R = pars (mini False t)
t@(Lam _ _) `on` _ = pars (mini False t)
t           `on` _ = mini True t




-------------------- test cases (Y, multiply, predecessor, etc.)

y = Lam 'f' (App (Lam 'x' (App (Var 'f') (App (Var 'x') (Var 'x')))) 
                 (Lam 'x' (App (Var 'f') (App (Var 'x') (Var 'x')))))

m = Lam 'm' (Lam 'n' (Lam 'f' (App (Var 'm') (App (Var 'n') (Var 'f')))))

p = (Lam 'k' (Lam 'f' (Lam 'x' (App (App (App (Var 'k') 
    (Lam 'g' (Lam 'h' (App (Var 'h') (App (Var 'g') (Var 'f')))))) 
             (Lam 'u' (Var 'x'))) (Lam 'u' (Var 'u'))))))

ab    = App (Var 'a') (Var 'b')
dub x = Lam 'a' (App x x)

etc = dub (dub ab)
abs = dub (Lam 'f' (Lam 'x' etc))
