
module RCalc where

import Parse
import Parsing (run, parse)
import Reduce
import Calc


-------------------- some calculators for terms:

-- rcalc: reducing claculator (normal lambda+defns input)
-- acalc: arithmetic calculator (infix math input)
-- tcalc: tracing calculator (math input, hit enter for steps)
-- ncalc: normal-form calculator (math input, no steps)


rcalc = scalc (parse term)  fmtred
acalc = scalc (parse arith) fmtred
tcalc = scalc (parse arith) (stepr . reds)
ncalc = scalc (parse arith) (fmt "->>" . last . reds)


-------------------- formatted and stepped reductions

fmtred e = fmt "==" e >> mapM_ (fmt "->") (reds e)

stepr es = foldr (\e r -> fmtNln e >> getLine >> r) (return ()) es