
module Utils where

import Char
import Parsing


-------------------- general function utilities

left  f (x,y) = (f x, y)
right f (x,y) = (x, f y)

upd f x v y = if y==x then v else f y


-------------------- printing utilities

data Side = L | R

infixr 5 +|+
(+|+) x y = x++" "++y

paren t = "(" ++ show t ++ ")"

ascii = True
lam = if ascii then "\\" else "?"


-------------------- parsing utilities

low = token (sat isLower)
ups = token (many1 (sat isUpper))

as p f = p >>= return . f

par p = do { symbol "("; v <- p; symbol ")"; return v }

opr ap s p = symbol s >> return (ap . ap p)

alg ap c n m = a where a = foldl chainl1 (c +++ par a) $ zipWith (opr ap) n m
