
module XBase where

import Defns
import Utils


-------------------- abstract syntax for EXTENDED lambda terms

data Term = Zero | Succ Term | Var Char | App Term Term | Lam Char Term


-------------------- pretty-printing

instance Show Term where
  show  Zero     = "0"
  show (Var x)   = [x]
  show (Succ n)  = "$" +|+ n `on` R
  show (App m n) = m `on` L +|+ n `on` R
  show  m        = lam ++ vs ++ "." +|+ show b
                   where (vs,b) = vars m

vars (Lam x n) = left (x:) (vars n)
vars t = ([],t)

t@(App _ _) `on` R = paren t
t@(Succ  _) `on` R = paren t 
t@(Lam _ _) `on` _ = paren t
t           `on` _ = show t
