
module XDeno where

import Utils
import XBase


-------------------- semantic domain

data Dom  = Num Integer | Fun (Dom -> Dom)

instance Show Dom where
  show (Num n) = show n
  show (Fun f) = "<function>"


-------------------- denotational semantics

sem env  Zero     = Num 0
sem env (Succ m)  = case sem env m of
                      Num k -> Num (k+1)
                      Fun _ -> error "successor of a function"
sem env (Var x)   = env x
sem env (Lam x m) = Fun (\z -> sem (upd env x z) m)
sem env (App m n) = case sem env m of
                      Fun f -> f (sem env n)
                      Num _ -> error "applied a number"

val = sem undefined

num m = val (App (App m (Lam 'x' (Succ (Var 'x')))) Zero)
