
module XParse where

import XBase
import Utils
import Defns
import Parsing


-------------------- parsing for terms

term = do symbol "$"
          term `as` Succ
     +++
       do (symbol "λ" +++ symbol "\\")
          vs <- many1 low
          symbol "."
          t <- term
          return (foldr Lam t vs)
     +++    
          many1 atom `as` foldl1 App

meta = expand (menv (run term))


-------------------- parsing for atoms (incl. meta-variables and Church numerals)

atom = symbol "0" `as` const Zero
   +++ 
       low `as` Var
   +++ 
       ups `as` meta
   +++ 
       (symbol "#" >> (nat `as` church))
   +++ 
       par term


-------------------- Church numerals

church n = Lam 'f' (Lam 'x' (ch n))
           where ch 0 = Var 'x'
                 ch n = App (Var 'f') (ch (n-1))


-------------------- algebraic parser

lit = many1 digit `as` (church . read)

arith = alg App lit ["^","*","+"] (map meta ["POW","MUL","ADD"])
